"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var THREE = _interopRequireWildcard(require("three"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var ThreeJSR =
/*#__PURE__*/
function () {
  function ThreeJSR(ref, newFrameHook) {
    _classCallCheck(this, ThreeJSR);

    this.ref = ref;
    this.newFrameHook = newFrameHook;
    this.camera = {};
  }

  _createClass(ThreeJSR, [{
    key: "afterMount",
    value: function afterMount(width, height) {
      ThreeJSR.verifyEnv();
      this.createThreeScene();
      this.renderer = new THREE.WebGLRenderer({
        antialias: true
      });
      this.onResize(width, height);
      this.ref.current.appendChild(this.renderer.domElement);
      this.renderer.render(this.scene, this.camera);
      this.frameId = requestAnimationFrame(this.newFrameHook);
    }
  }, {
    key: "renderNextFrame",
    value: function renderNextFrame() {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          timestamp = _ref.timestamp;

      if (timestamp) {
        this.renderer.render(this.scene, this.camera);
        this.frameId = requestAnimationFrame(this.newFrameHook);
      }
    }
  }, {
    key: "cleanup",
    value: function cleanup() {
      if (this.frameId) {
        cancelAnimationFrame(this.frameId);
      }
    }
  }, {
    key: "createThreeScene",
    value: function createThreeScene() {
      throw new Error('must implement createThreeScene()');
    }
  }, {
    key: "onResize",
    value: function onResize(width, height) {
      if (!width || !height) return;
      var heightChanged = Math.abs(this.height - height) > 20;
      var widthChanged = Math.abs(this.width - width) > 20;
      if (!heightChanged && !widthChanged && this.width && this.height) return;
      this.width = width;
      this.height = Math.max(height, 200);
      this.camera.aspect = this.width / this.height;
      this.camera.updateProjectionMatrix();
      this.renderer.setSize(this.width, this.height);
    }
  }], [{
    key: "verifyEnv",
    value: function verifyEnv() {
      try {
        var canvas = document.createElement('canvas');
        var meetsRequirements = !!(window.WebGLRenderingContext && (canvas.getContext('webgl') || canvas.getContext('experimental-webgl')));

        if (!meetsRequirements) {
          throw new Error();
        }
      } catch (e) {
        throw new Error('WebGL is not available');
      }
    }
  }]);

  return ThreeJSR;
}();

exports["default"] = ThreeJSR;