"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _reactn = _interopRequireWildcard(require("reactn"));

var _threejsR = require("threejs-r");

require("./ThreeJSRComponent.css");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ThreeJSRComponent(props) {
  var _useGlobal = (0, _reactn.useGlobal)('threejsr'),
      _useGlobal2 = _slicedToArray(_useGlobal, 2),
      threejsr = _useGlobal2[0],
      setThreejsr = _useGlobal2[1];

  var ref = (0, _reactn.useRef)();
  var dim = ref.current && ref.current.getBoundingClientRect();

  var _ref = dim || {},
      width = _ref.width,
      height = _ref.height;

  var _useState = (0, _reactn.useState)(function () {
    return new props.ThreeJSR(ref, function (timestamp) {
      return setThreejsr({
        timestamp: timestamp
      });
    });
  }),
      _useState2 = _slicedToArray(_useState, 1),
      threejs = _useState2[0];

  (0, _reactn.useEffect)(function () {
    threejs.afterMount(width, height);
    return function () {
      return threejs.cleanup();
    };
  }, []);
  (0, _reactn.useEffect)(function () {
    threejs.onResize(width, height);
  }, [width, height]);
  (0, _reactn.useEffect)(function () {
    threejs.renderNextFrame(threejsr || {});
  }, [threejsr]);
  return _reactn["default"].createElement("div", {
    className: "full-screen fixed-top z--1",
    ref: ref
  });
}

ThreeJSRComponent.propTypes = {
  ThreeJSR: function ThreeJSR(props, propName) {
    if (!(props[propName].prototype instanceof _threejsR.ThreeJSR)) {
      return new Error('ThreeJSR prop should be an instance of ThreeJSR');
    }
  }
};
var _default = ThreeJSRComponent;
exports["default"] = _default;